<template>
	<div v-if="cartItemHasSubscription">
		<span
			v-if="!isFilter && showIncludes"
			class="”screen-reader-only”"
			:aria-label="`Includes ${cartItemSubscriptionData.period} months of filters`"
		></span>
		<p
			v-if="!isFilter && showIncludes"
			aria-hidden="”true”"
			class="text-sm leading-5 mt-2 font-primary-font-light sc-includes"
		>
			Includes {{ cartItemSubscriptionData.period }} mos. of filters
		</p>
		<div v-if="!isFilter" class="mt-1">
			<div>
				<div class="flex items-center">
					<p
						aria-hidden="true"
						class="font-primary-font-regular text-sm mr-2"
						:class="$route.query.status == 'inactive' ? 'text-error-20' : 'text-black'"
					>
						{{
							affirmState
								? 'Auto-refills ' + ($route.query.status ? $route.query.status : 'inactive')
								: 'Features auto-refills'
						}}
					</p>
					<div
						v-if="showTooltip"
						class="inline-block relative group w-4 h-4 mb-0.5 mk-tooltip"
						role="tooltip"
						tabindex="0"
						@mouseover="calculatePosition($event)"
						@focus="calculatePosition($event)"
					>
						<span class="icon-notification" aria-label="Features auto-refills tooltip"></span>
						<MkCartTooltip class="hidden group-hover:block z-50" :rotate-left="true" :icon-position="toolTipPosition">
							<template #tooltipRightValue>
								<div class="text-sm leading-tablet-title font-primary-font-light pr-0.25">
									<p v-if="cartItemSubscriptionData.productName" class="font-primary-font-bold">
										{{ cartItemSubscriptionData.productName }}: auto-refills
									</p>
									<div>
										<p :class="showTooltipOption ? 'block' : 'hidden'" class="mt-1 screen-reader-only">
											${{ cartItemSubscriptionData.price.centAmount | centsToDollars }} /
											{{ cartItemSubscriptionData.period }} months.
										</p>
										<p aria-hidden="true" :class="showTooltipOption ? 'block' : 'hidden'" class="mt-1">
											${{ cartItemSubscriptionData.price.centAmount | centsToDollars }} /
											{{ cartItemSubscriptionData.period }} mos.
										</p>
										<p :class="showTooltipOption ? 'block' : 'hidden'" class="pt-5">
											Every {{ cartItemSubscriptionData.period }} months you get:
										</p>
										<p v-if="cartItemSubscriptionData.productDescription" class="pt-0.5">
											{{ cartItemSubscriptionData.productDescription }}
										</p>
										<p class="mt-1 font-primary-font-bold screen-reader-only">
											${{ cartItemSubscriptionData.price.centAmount | centsToDollars }} every
											{{ cartItemSubscriptionData.period }} months.
										</p>
										<p aria-hidden="true" class="mt-1 font-primary-font-bold">
											${{ cartItemSubscriptionData.price.centAmount | centsToDollars }} every
											{{ cartItemSubscriptionData.period }} mos.
										</p>
										<p
											:class="showTooltipOption ? 'block' : 'hidden'"
											class="font-primary-font-light-italic mt-2 text-xs"
										>
											Sales tax may apply.
										</p>
										<p
											:class="showTooltipOption ? 'block' : 'hidden'"
											class="font-primary-font-light text-sm leading-5 mt-6 md:mt-4 lg:mt-6 mb-0 lg:mb-2"
										>
											Next refill:
											{{ createNextRefill(item['cartItemSubscriptionData']['period']) }}
										</p>
										<p :class="showTooltipOption ? 'block' : 'hidden'" class="pt-4 font-primary-font-light-italic w-44">
											Cancel auto-refills anytime in your account.
										</p>
									</div>
								</div>
							</template>
						</MkCartTooltip>
					</div>
				</div>
			</div>
			<p
				v-if="affirmState && !$route.path.includes('/checkout/orderSuccess')"
				class="text-sm mr-2"
				:class="$route.query.status == 'inactive' ? 'text-error-20' : 'text-black'"
			>
				${{ cartItemSubscriptionData.price.centAmount | centsToDollars }} every
				{{ cartItemSubscriptionData.period }} mos. per device
			</p>
			<p
				v-if="
					($route.path.includes('/checkout/orderSuccess') && $route.query.status == 'inactive') ||
					(!$route.path.includes('/checkout/orderSuccess') && affirmState)
				"
				class="font-primary-font-bold text-sm mr-2"
				:class="$route.query.status == 'inactive' ? 'text-error-20' : 'text-black'"
			>
				Requires sign-up after purchase
			</p>
		</div>
	</div>
</template>
<script>
import MkCartTooltip from '~/components/D2C/atoms/MkCartTooltip.vue';
export default {
	name: 'MkFilterSubscription',
	components: {
		MkCartTooltip,
	},
	props: {
		item: {
			type: [Object, String, Array],
			default() {
				return {};
			},
		},
		showTooltip: {
			type: Boolean,
			default: false,
		},
		showIncludes: {
			type: Boolean,
			default: true,
		},
		showTooltipOption: {
			type: Boolean,
			default: false,
		},
		paymentData: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			toolTipPosition: null,
			paymentDetail: {},
			affirmState: false,
		};
	},
	computed: {
		cartItemHasSubscription() {
			return this.item.cartItemHasSubscription;
		},
		cartItemSubscriptionData() {
			return this.item.cartItemSubscriptionData;
		},
		isFilter() {
			const isFilter =
				this.item &&
				this.item.productType &&
				this.item.productType.obj &&
				this.item.productType.obj.key &&
				this.item.productType.obj.key === 'filter';

			return isFilter;
		},
	},
	watch: {
		paymentData: {
			deep: true,
			handler() {
				this.paymentDetail = this.paymentData;
				this.affirmState = this.paymentData && this.paymentData.selectedAffirm;
			},
		},
	},
	mounted() {
		this.affirmState = this.$route.query.status ? true : this.affirmState;
	},
	methods: {
		calculatePosition(event) {
			this.toolTipPosition = null;
			const clPoints = event.target.getClientRects()[0];
			this.toolTipPosition = { event, iconPosition: clPoints.y };
		},
		createNextRefill(value) {
			if (value) {
				const d = new Date();
				d.setMonth(d.getMonth() + value);
				return this.$options.filters.formatDateAurora(d, 'MM/DD/YYYY');
			}
		},
	},
};
</script>
